Imports System.Data.OleDb

Public Class Form1
    Private conn As New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=Nordwind.mdb;")
    Private da As OleDbDataAdapter = Nothing
    Private ds As DataSet = Nothing

    Public Function getArtikel() As DataSet
        ' SelectCommand fr DataAdapter erstellen (geschieht automatisch beim Instanziieren):
        Dim selStr As String = _
        "SELECT ArtikelNr, Artikelname, Einzelpreis, Mindestbestand FROM Artikel ORDER BY Artikelname"
        da = New OleDbDataAdapter(selStr, conn)
        ' Neu hinzugefgte Datenstze erhalten sofort einen Primrschlssel:
        da.MissingSchemaAction = MissingSchemaAction.AddWithKey
        conn.Open()
        Dim ds As New DataSet()
        da.Fill(ds, "Artikel")
        conn.Close()
        Return ds
    End Function

    Public Sub setArtikel(ByRef ds As DataSet)
        ' UpdateCommand-Objekt: -----------------------------------------------------------------------
        Dim updStr As String = "UPDATE Artikel SET Artikelname = @p1, Einzelpreis = @p2, " & _
                               "Mindestbestand = @p3 WHERE ArtikelNr = @p4"
        Dim updCmd As New OleDbCommand(updStr, conn)
        ' Parameterdefinition mittels Add-Methode bentigt Parametername, Datentyp, Spaltenbreite, Spaltenname (Reihenfolge beachten!):
        updCmd.Parameters.Add("@p1", OleDbType.VarChar, 40, "Artikelname")
        updCmd.Parameters.Add("@p2", OleDbType.Currency, 8, "Einzelpreis")
        updCmd.Parameters.Add("@p3", OleDbType.SmallInt, 4, "Mindestbestand")
        Dim p4 As OleDbParameter = updCmd.Parameters.Add("@p4", OleDbType.BigInt)
        ' Fr die Schlsselspalte ist der ursprngliche Schlsselwert magebend:
        p4.SourceColumn = "ArtikelNr"
        p4.SourceVersion = DataRowVersion.Original
        da.UpdateCommand = updCmd
        ' InsertCommand-Objekt: -------------------------------------------------------------------------
        ' INSERT-Befehl werden drei Parameter bergeben:
        Dim insSQL As String = "INSERT INTO Artikel (Artikelname, Einzelpreis, Mindestbestand) VALUES (@p1, @p2, @p3)"
        Dim insCmd As New OleDbCommand(insSQL, conn)
        insCmd.Parameters.Add("@p1", OleDbType.VarChar, 40, "Artikelname")
        insCmd.Parameters.Add("@p2", OleDbType.Currency, 8, "Einzelpreis")
        insCmd.Parameters.Add("@p3", OleDbType.SmallInt, 4, "Mindestbestand")
        da.InsertCommand = insCmd
        ' DeleteCommand-Objekt: --------------------------------------------------------------------------
        ' Die zugrundeliegende DELETE-Anweisung bentigt  nur einen Parameter (den Primrschlssel). Beim Erzeugen des Parameters ist auch noch die SourceVersion-Eigenschaft zuzuweisen. Der Wert Original bedeutet, dass der Datensatz mit seinem Original-Schlsselwert (also der ArtikelNr, die er bei seinem Eintreffen in der DataTable hatte) in der Datenbank gesucht und gelscht wird:
        Dim delStr As String = "DELETE FROM Artikel WHERE ArtikelNr = @p5"
        Dim delCmd As New OleDbCommand(delStr, conn)
        Dim p5 As OleDbParameter = delCmd.Parameters.Add("@p5", OleDbType.BigInt, 4, "ArtikelNr")
        ' Datensatz muss unverndert in der Datenquelle vorhanden sein: 
        p5.SourceVersion = DataRowVersion.Original
        da.DeleteCommand = delCmd

        conn.Open()
        da.Update(ds, "Artikel")
        conn.Close()
    End Sub

    ' Anzeigen:
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        DataGridView1.DataSource = Nothing
        ds = getArtikel()
        DataGridView1.DataSource = ds        ' DataGridView mit DataSet verbinden
        DataGridView1.DataMember = "Artikel"
        formatDataGridView(DataGridView1)
    End Sub


    ' Aktualisieren:
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim ds1 As DataSet = ds.GetChanges()
        If ds1 IsNot Nothing Then
            Try
                setArtikel(ds1)
                ' Die per Referenz zurckgegebenen Datenstze werden mit dem Original-DataSet zusammengefhrt:
                ds.Merge(ds1)
                ds.AcceptChanges()
                MessageBox.Show("Datenbank wurde aktualisiert!", "Erfolg")
            Catch ex As Exception
                ds.RejectChanges()
                MessageBox.Show(ex.Message, "Fehler")
            End Try
        End If
    End Sub

    Private Sub formatDataGridView(ByVal dgv As DataGridView)
        ' Einzelpreis formatieren:
        dgv.Columns.Remove("Einzelpreis")
        Dim tbc As New DataGridViewTextBoxColumn()
        tbc.DataPropertyName = "Einzelpreis"
        tbc.HeaderText = "Einzelpreis"
        tbc.Width = 80
        tbc.DefaultCellStyle.Format = "c"
        tbc.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
        tbc.DefaultCellStyle.Font = New Font(DataGridView1.Font, FontStyle.Bold)
        tbc.DisplayIndex = 2
        dgv.Columns.Add(tbc)
    End Sub

    
End Class
