Imports System.Data.OleDb

Public Class Form1
    Private s As String = String.Empty
    Private dt As DataTable = Nothing
    Private da As OleDbDataAdapter = Nothing

    Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
        Dim conn As New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0; Data Source=Nordwind.mdb;")
        da = New OleDbDataAdapter("SELECT TOP 1 ArtikelNr, Artikelname, Lagerbestand FROM Artikel", conn)
        ' Ereignisbehandlungen hinzufgen:
        AddHandler da.RowUpdating, AddressOf OnRowUpdating
        AddHandler da.RowUpdated, AddressOf OnRowUpdated
        dt = New DataTable("Artikel")
        da.Fill(dt)

        ' Dim cb As New OleDbCommandBuilder(da)
        ' oder
        Dim cmd As New OleDbCommand("UPDATE Artikel SET Lagerbestand = ? WHERE ArtikelNr = ?", conn)
        cmd.Parameters.Add("@p1", OleDbType.Integer, 4, "Lagerbestand")
        cmd.Parameters.Add("@p2", OleDbType.Integer, 4, "ArtikelNr")
        da.UpdateCommand = cmd

        MyBase.OnLoad(e)
    End Sub

    Private Sub OnRowUpdating(ByVal sender As Object, ByVal e As OleDbRowUpdatingEventArgs)
        s &= "Ereignis: " & e.StatementType.ToString() & vbCrLf
        s &= "Artikel-Nr: " & e.Row("ArtikelNr").ToString() & vbCrLf
        s &= "Lagerbestand davor: " & e.Row("Lagerbestand", DataRowVersion.Original).ToString() & vbCrLf
        s &= "Lagerbestand danach: " & e.Row("Lagerbestand").ToString() & vbCrLf & vbCrLf
    End Sub

    Private Sub OnRowUpdated(ByVal sender As Object, ByVal e As OleDbRowUpdatedEventArgs)
        s &= "Ereignis: " & e.StatementType.ToString() & vbCrLf
        s &= "Artikel-Nr: " & e.Row("ArtikelNr").ToString() & vbCrLf
        If e.Status = UpdateStatus.ErrorsOccurred Then
            s &= "Fehler!" & vbCrLf
        Else
            s &= "Update erfolgreich!" & vbCrLf & vbCrLf
        End If
        Label1.Text = s
        s = String.Empty
    End Sub

    ' Lagerbestand verndern:
    Private Sub changeStock(ByVal z As Integer)
        Try
            Dim dr As DataRow = dt.Rows(0)  ' erste (und einzige!) Zeile der DataTable
            Dim i As Integer = Convert.ToInt32(dr("Lagerbestand"))
            dt.Rows(0)("Lagerbestand") = i + z
            da.Update(dt)
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    ' Lagerbestand erhhen:
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        changeStock(1)
    End Sub

    ' Lagerbestand verringern:
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        changeStock(-1)
    End Sub
End Class
