Imports System.Data
Imports System.Data.OleDb

Public Class Form1
    Private conn As New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=Nordwind.mdb;")

    Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
        Try
            conn.Open()
            showKundenTable()
            setMaxLength()
        Catch ex As Exception
            MessageBox.Show(ex.Message.ToString())
        Finally
            conn.Close()
        End Try
        MyBase.OnLoad(e)
    End Sub

    Private Sub showKundenTable()
        Dim da As New OleDbDataAdapter("SELECT KundenCode, Firma, Kontaktperson, Funktion FROM Kunden", conn)
        Dim dt As New DataTable()
        ' Die BindingSource mit der DataTable synchronisieren:
        BindingSource1.DataSource = dt
        da.Fill(dt)
        ' Die Text-Eigenschaft der  Steuerelemente anbinden:
        Label1.DataBindings.Add("Text", BindingSource1, "KundenCode")
        TextBox1.DataBindings.Add("Text", BindingSource1, "Firma")
        TextBox2.DataBindings.Add("Text", BindingSource1, "Kontaktperson")
        TextBox3.DataBindings.Add("Text", BindingSource1, "Funktion")
    End Sub

    Private Sub setMaxLength()
        ' Ein String-Array kapselt die Filterbedingungen:
        Dim filter() As String = {Nothing, Nothing, "Kunden", Nothing}
        ' Abfrage des Schemas, Ergebnis wird in DataTable geladen:
        Dim dt As DataTable = conn.GetSchema("Columns", filter)
        ' Alle Zeilen der Schematabelle durchlaufen, in jeder Zeile sind die Infos zu einer bestimmten Spalte enthalten:
        For i As Integer = 0 To dt.Rows.Count - 1
            Dim fName As String = dt.Rows(i)("COLUMN_NAME").ToString()
            ' Die maximal zulssige Anzahl von Zeichen:
            Dim fLen As Integer = Convert.ToInt32(dt.Rows(i)("CHARACTER_MAXIMUM_LENGTH"))
            Select Case fName
                Case "Firma" : TextBox1.MaxLength = fLen
                    Label7.Text = fLen.ToString()
                Case "Kontaktperson" : TextBox2.MaxLength = fLen
                    Label8.Text = fLen.ToString()
                Case "Funktion" : TextBox3.MaxLength = fLen
                    Label9.Text = fLen.ToString()
            End Select
        Next
    End Sub
End Class
