Imports System.IO

Public Class Form1
    Private dt As DataTable = Nothing

    Private Function getDataTable() As DataTable
        Dim dt As New DataTable("Belege")
        Dim col0 As DataColumn = dt.Columns.Add("Nr", Type.GetType("System.Int32"))
        col0.AutoIncrement = True
        col0.AutoIncrementStep = 1

        Dim col1 As DataColumn = dt.Columns.Add("EingangsDatum", Type.GetType("System.DateTime"))
        col1.AllowDBNull = False
        col1.DefaultValue = DateTime.Now

        Dim col2 As DataColumn = dt.Columns.Add("KuNr", Type.GetType("System.Int32"))
        col2.AllowDBNull = False

        Dim col3 As DataColumn = dt.Columns.Add("GesamtNetto", Type.GetType("System.Decimal"))
        col3.DefaultValue = 0

        Dim col4 As DataColumn = dt.Columns.Add("Bemerkung", Type.GetType("System.String"))
        col4.DefaultValue = ""
        col4.MaxLength = 50
        Return dt
    End Function

    Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
        dt = getDataTable()
        DataGridView1.DataSource = dt          ' Datengitter an DataTable anbinden
        formatDataGridView(DataGridView1)      ' ... und formatieren

        MyBase.OnLoad(e)
    End Sub

    ' von Datei laden:
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        dt.ReadXml("Belege.xml")
    End Sub


    ' in Datei abspeichern
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        dt.WriteXml("Belege.xml", XmlWriteMode.WriteSchema)
    End Sub

    ' Anzeige lschen:
    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        dt.Clear()
    End Sub

    ' Anzeige formatieren:
    Private Sub formatDataGridView(ByVal dgv As DataGridView)
        ' Datum formatieren:
        dgv.Columns.Remove("EingangsDatum")
        Dim tbc1 As New DataGridViewTextBoxColumn()
        tbc1.DataPropertyName = "EingangsDatum"
        tbc1.HeaderText = "EingangsDatum"
        tbc1.Width = 90
        tbc1.DefaultCellStyle.Format = "d"
        tbc1.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter
        tbc1.DisplayIndex = 1
        dgv.Columns.Add(tbc1)

        ' Whrung formatieren:
        dgv.Columns.Remove("GesamtNetto")
        Dim tbc2 As New DataGridViewTextBoxColumn()
        tbc2.DataPropertyName = "GesamtNetto"
        tbc2.HeaderText = "GesamtNetto"
        tbc2.Width = 80
        tbc2.DefaultCellStyle.Format = "c"
        tbc2.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
        tbc2.DefaultCellStyle.Font = New Font(DataGridView1.Font, FontStyle.Bold)
        tbc2.DisplayIndex = 3
        dgv.Columns.Add(tbc2)
    End Sub
End Class
