Imports System.IO

Public Class Form1

    Public Function ConvertUntypedToTypedDS(ByVal ds As DataSet) As DataSet1
        Dim stream As MemoryStream = Nothing
        Try
            stream = New MemoryStream()
            ' DataSet inkl. Strukturinfo in den MemoryStream schreiben:
            ds.WriteXml(stream, XmlWriteMode.WriteSchema)
            ' Position im MemoryStream auf Anfang zurcksetzen:
            stream.Seek(0, SeekOrigin.Begin)
            ' Typisiertes DataSet instanziieren und Inhalt des MemoryStreams einlesen:
            Dim ds1 As New DataSet1()
            ds1.ReadXml(stream, XmlReadMode.InferSchema)
            Return ds1
        Catch
            Return Nothing
        Finally
            If stream IsNot Nothing Then stream.Close()
        End Try
    End Function

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim ds As DataSet = getTestDS()

        MessageBox.Show(ds.Tables("Personen").Rows(0)("Vorname").ToString)

        Dim ds1 As DataSet1 = ConvertUntypedToTypedDS(ds)

        DataGrid1.DataSource = ds1
        MessageBox.Show(ds1.Personen(0).Vorname)

    End Sub


    Private Function getTestDS() As DataSet

        'Tabelle Personen:
        Dim dt1 As New DataTable("Personen")
        'Primrschlssel:
        Dim col1 As DataColumn = dt1.Columns.Add("Nr", Type.GetType("System.Int32"))
        col1.AllowDBNull = False
        col1.Unique = True
        col1.AutoIncrement = True
        col1.AutoIncrementStep = 1

        ' restliche Spalten hinzufgen:
        dt1.Columns.Add("Vorname", Type.GetType("System.String"))
        dt1.Columns.Add("Nachname", Type.GetType("System.String"))
        dt1.Columns.Add("Geburtstag", Type.GetType("System.DateTime"))

        ' zwei Datenstze hinzufgen:
        Dim rw11 As DataRow = dt1.NewRow()
        rw11("Vorname") = "Klaus"
        rw11("Nachname") = "Mller"
        rw11("Geburtstag") = Convert.ToDateTime("3.4.1975")
        Dim rw12 As DataRow = dt1.NewRow()
        rw12("Vorname") = "Tobalt"
        rw12("Nachname") = "Tonne"
        rw12("Geburtstag") = Convert.ToDateTime("5.8.1984")
        dt1.Rows.Add(rw11)
        dt1.Rows.Add(rw12)

        ' Tabelle Bestellungen:
        Dim dt2 As New DataTable("Bestellungen")
        Dim col2 As DataColumn = dt2.Columns.Add("Nr", Type.GetType("System.Int32"))
        col2.AllowDBNull = False
        col2.Unique = True
        col2.AutoIncrement = True
        col2.AutoIncrementStep = 1
        dt2.Columns.Add("Datum", Type.GetType("System.DateTime"))
        dt2.Columns.Add("Betrag", Type.GetType("System.Decimal"))
        dt2.Columns.Add("PersNr", Type.GetType("System.Int32"))           ' Fremdschlssel
        dt2.Columns.Add("Bemerkung", Type.GetType("System.String"))

        ' Zwei Datenstze hinzufgen:
        Dim rw21 As DataRow = dt2.NewRow()
        rw21("Datum") = Convert.ToDateTime("20.2.2006")
        rw21("Betrag") = Convert.ToDecimal("256,50")
        rw21("PersNr") = 0
        rw21("Bemerkung") = "per Nachname"
        dt2.Rows.Add(rw21)
        Dim rw22 As DataRow = dt2.NewRow()
        rw22("Datum") = Convert.ToDateTime("8.3.2006")
        rw22("Betrag") = Convert.ToDecimal("12,95")
        rw22("PersNr") = 0
        rw22("Bemerkung") = "per Scheck"
        dt2.Rows.Add(rw22)

        ' DataSet zusammenbauen (mit 1 : n Relation zwischen Kunden und Bestellungen):
        Dim ds As New DataSet()
        ds.Tables.Add(dt1)
        ds.Tables.Add(dt2)
        ds.Relations.Add("Person_Bestellungen", ds.Tables("Personen").Columns("Nr"), _
                                              ds.Tables("Bestellungen").Columns("PersNr"))
        Return ds
    End Function
End Class
