Imports System.Data.OleDb

Public Class Form1
    Private da As OleDbDataAdapter = Nothing
    Private dt As DataTable = Nothing
    ' Die BindingSource verbindet die Anzeige-Controls mit der DataTable.      
    Private bs As New BindingSource()

    Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
        Dim connStr As String = "Provider=Microsoft.Jet.OLEDB.4.0; Data Source=Nordwind.mdb;"
        Dim conn As New OleDbConnection(connStr)
        Dim selStr As String = "SELECT * FROM Personal"
        da = New OleDbDataAdapter(selStr, conn)
        da.MissingSchemaAction = MissingSchemaAction.AddWithKey
        Dim cb As New OleDbCommandBuilder(da)
        ' Ausfhren der SQL-Abfrage (Anlegen und Fllen der Tabelle Personal): 
        dt = New DataTable("Personal")
        conn.Open()
        da.Fill(dt)
        conn.Close()
        ' Zuweisen der BindingSource:
        bs.DataSource = dt

        ' Anbinden der Eingabemaske an die DataTable:
        Label1.DataBindings.Add("Text", bs, "PersonalNr")
        TextBox1.DataBindings.Add("Text", bs, "Vorname")
        TextBox2.DataBindings.Add("Text", bs, "Nachname")
        TextBox4.DataBindings.Add("Text", bs, "Funktion")
        ' Datumsformatierung:
        Dim b1 As New Binding("Text", bs, "Geburtsdatum")
        AddHandler b1.Format, New ConvertEventHandler(AddressOf Me.DateToDateString)
        AddHandler b1.Parse, New ConvertEventHandler(AddressOf Me.DateStringToDate)
        TextBox3.DataBindings.Add(b1)
        ' Whrungsformatierung:
        Dim b2 As New Binding("Text", bs, "Monatsgehalt")
        AddHandler b2.Format, New ConvertEventHandler(AddressOf Me.DecToCurrString)
        AddHandler b2.Parse, New ConvertEventHandler(AddressOf Me.CurrStringToDec)
        TextBox5.DataBindings.Add(b2)

        MyBase.OnLoad(e)
    End Sub

    ' Geburtsdatum:
    Private Sub DateToDateString(ByVal sender As Object, ByVal e As ConvertEventArgs) 'DataTable => Anzeige
        Try
            e.Value = Convert.ToDateTime(e.Value).ToString("d.M.yyyy")
        Catch
        End Try
    End Sub

    Private Sub DateStringToDate(ByVal sender As Object, ByVal e As ConvertEventArgs)   ' Anzeige => DataTable
        e.Value = Convert.ToDateTime(e.Value)
    End Sub
    ' Formatierung des Gehalts als Whrung: 
    Private Sub DecToCurrString(ByVal sender As Object, ByVal e As ConvertEventArgs)     ' DataTable => Anzeige
        Try
            e.Value = Convert.ToDecimal(e.Value).ToString("c")
        Catch
        End Try
    End Sub

    Private Sub CurrStringToDec(ByVal sender As Object, ByVal e As ConvertEventArgs)     ' Anzeige => Datenquelle
        e.Value = Convert.ToDecimal(e.Value)
    End Sub

    ' Bewegungsmethoden:
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        bs.MoveFirst()
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        bs.MovePrevious()
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        bs.MoveNext()
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        bs.MoveLast()
    End Sub

    ' Neu
    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        bs.AddNew()
    End Sub

    ' Lschen
    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        bs.RemoveCurrent()
    End Sub

    ' Speichern
    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
        bs.EndEdit()
        da.Update(dt)
    End Sub

    ' Abbrechen
    Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click
        bs.CancelEdit()
    End Sub
End Class
