Imports System.Data.OleDb

Public Class Form1
    Private Const CONNSTR As String = "Provider=Microsoft.Jet.OLEDB.4.0; Data Source=Nordwind.mdb;"

    ' Mit DB verbinden:
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Const SQLSTR As String = "SELECT KundenCode, Firma, Funktion FROM Kunden"
        Dim conn As New OleDbConnection(CONNSTR)
        Dim cmd As New OleDbCommand(SQLSTR, conn)
        Dim dr As OleDbDataReader = Nothing
        With ListView1
            .Items.Clear()
            .View = View.Details
            .AllowColumnReorder = True
            .FullRowSelect = True
            .Columns.Add("KundenCode", 80, HorizontalAlignment.Center)
            .Columns.Add("Firma", 200, HorizontalAlignment.Left)
            .Columns.Add("Funktion", 120, HorizontalAlignment.Left)
        End With

        Try
            conn.Open()
            dr = cmd.ExecuteReader(CommandBehavior.CloseConnection)     ' DataReader wird erzeugt
            Do While dr.Read()
                Dim lvItem As New ListViewItem(dr.Item("KundenCode").ToString)
                lvItem.SubItems.Add(dr.Item("Firma").ToString)
                lvItem.SubItems.Add(dr.Item("Funktion").ToString)
                ListView1.Items.Add(lvItem)    ' Items zum ListView hinzufgen
            Loop
        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            dr.Close()
        End Try
    End Sub

    ' Adresseninformation holen (bergabe der ID):
    Private Sub loadAddressInfo(ByVal kuCode As String)
        Dim SQL As String = "SELECT Kontaktperson, Strasse, PLZ, Ort FROM Kunden WHERE KundenCode = ?"
        Dim conn As New OleDbConnection(CONNSTR)
        Dim cmd As New OleDbCommand(SQL, conn)
        Dim prm As New OleDbParameter("@p", OleDbType.Char)
        Dim dr As OleDbDataReader = Nothing
        prm.Direction = Data.ParameterDirection.Input
        prm.Value = kuCode
        cmd.Parameters.Add(prm)
        Try
            conn.Open()
            dr = cmd.ExecuteReader(CommandBehavior.CloseConnection)
            If (dr.Read()) Then
                Label1.Text = dr.Item("Kontaktperson").ToString & ControlChars.CrLf & _
                dr.Item("Strasse").ToString & " " & _
                dr.Item("PLZ").ToString & " " & _
                dr.Item("Ort").ToString
            End If
        Finally
            dr.Close()
            conn.Close()
        End Try
    End Sub

    ' Eintrag auswhlen:
    Private Sub ListView1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListView1.Click
        Dim lv As ListViewItem = ListView1.SelectedItems(0)
        loadAddressInfo(lv.SubItems(0).Text)
    End Sub
End Class
