Public Class Form1
    Private dtA As DataTable = Nothing
    ' hart codierte Hilfstabelle fr die gltigen Mehrwertsteuerstze:   
    Private dtMWSt As DataTable = Nothing

    Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
        dtMWSt = createMWStTbl()
        MyBase.OnLoad(e)
    End Sub

    Private Function createMWStTbl() As DataTable
        Dim dt As New DataTable("MWSt")
        dt.Columns.Add("Nr", GetType(System.Byte))
        dt.Columns.Add("Betrag", GetType(System.String))
        Dim ma() As String = {"keine", "7%", "19%"}
        For i As Integer = 1 To 3               ' 3 Zeilen hinzufgen
            dt.Rows.Add(dt.NewRow())              '  neue leere Zeile
            dt.Rows(i - 1)(1) = ma(i - 1)         ' "Betrag" eintragen
        Next
        dt.Rows(0)(0) = 0    ' "Nr" eintragen (0, 7, 19)
        dt.Rows(1)(0) = 7
        dt.Rows(2)(0) = 19
        Return dt
    End Function

    ' Anzeigen:
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim bs As New BindingSource()
        Try
            dtA = CData.getAusgaben(TextBox1.Text, TextBox2.Text)
            If dtA Is Nothing Then
                DataGridView1.DataSource = Nothing
                ToolStripStatusLabel1.Text = "Zugriff nicht mglich!"

            Else
                bs.DataSource = dtA
                DataGridView1.Columns.Clear()
                DataGridView1.DataSource = bs
                ' Spalten formatieren
                DataGridView1.Columns.Remove("Nr")
                Dim tbc0 As New DataGridViewTextBoxColumn()
                tbc0.DataPropertyName = "Nr"
                tbc0.HeaderText = "Nr"
                tbc0.Width = 30
                tbc0.DisplayIndex = 0               ' erscheint an erster Position
                DataGridView1.Columns.Add(tbc0)
                DataGridView1.Columns.Remove("Netto")
                Dim tbc1 As New DataGridViewTextBoxColumn()
                tbc1.DataPropertyName = "Netto"
                tbc1.HeaderText = "Netto"
                tbc1.Width = 80                         ' Breite einstellen
                tbc1.DefaultCellStyle.Format = "c"
                tbc1.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
                tbc1.DefaultCellStyle.Font = New Font(DataGridView1.Font, FontStyle.Bold)
                tbc1.DefaultCellStyle.BackColor = Color.LightYellow
                tbc1.DisplayIndex = 2
                DataGridView1.Columns.Add(tbc1)
                ' MWSt-Spalte, in welcher man durch Aufklappen einer ComboBox bequem die gltigen Mehrwertsteuerstze auswhlen kann:
                DataGridView1.Columns.Remove("MWSt")
                Dim cbc0 As New DataGridViewComboBoxColumn()
                cbc0.DataSource = dtMWSt        ' Detailtabelle 
                cbc0.DataPropertyName = "MWSt"  ' Fremdschlssel  aus Primrtabelle
                cbc0.ValueMember = "Nr"         ' Primrschlssel aus Detailtabelle
                cbc0.DisplayMember = "Betrag"   ' Detailanzeige aus Detailtabelle
                cbc0.HeaderText = "MWSt"
                cbc0.DisplayIndex = 3
                cbc0.Width = 60
                cbc0.DisplayStyle = DataGridViewComboBoxDisplayStyle.Nothing
                DataGridView1.Columns.Add(cbc0)
                ' Spalten Datum und Bemerkung werden nicht formatiert, d.h., sie behalten ihre Standardwerte.

                ToolStripStatusLabel1.Text = bs.Count.ToString() & _
                            " Einnahmen zum Editieren von der Datenbank geladen!"
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message.ToString(), "Fehler beim Laden der DataTable!")
        End Try
    End Sub

    ' Speichern:
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        If dtA IsNot Nothing Then
            Try
                ' nur genderte Datenstze werden zurckgeschrieben:
                Dim dt1 As DataTable = dtA.GetChanges()      ' nderungen ermitteln
                If dt1 IsNot Nothing Then

                    ' Update gegen Datenbank fahren:
                    CData.setAusgaben(dt1)
                    ' Zusammenfhren beider DataTables:
                    dtA.Merge(dt1)
                    dtA.AcceptChanges()
                    ToolStripStatusLabel1.Text = "Alle nderungen wurden von der Datenbank bernommen!"
                Else
                    ToolStripStatusLabel1.Text = "Keine nderungen zum Speichern!"
                End If
            Catch ex As Exception
                MessageBox.Show(ex.Message.ToString, "Fehler beim Speichern der DataTable!")
                dtA.RejectChanges()
            End Try
        Else
            ToolStripStatusLabel1.Text = "Speichern nicht mglich!"
        End If
    End Sub

    ' Beenden:
    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Me.Close()
    End Sub
End Class
