﻿Option Strict On
Public Class Form

    Private dcNW As New NWDataContext()

    Public Sub New()

        ' Dieser Aufruf ist für den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fügen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.

        Dim orders = From ord In dcNW.Orders _
                     Order By ord.OrderDate _
                     Select ord

        BindingSourceOrders.DataSource = orders
        ' BindingSourceOrders.DataSource = dcNW.Orders

        Label1.DataBindings.Add("Text", BindingSourceOrders, "OrderID", True)
        TextBox1.DataBindings.Add("Text", BindingSourceOrders, "CustomerID", True)
        TextBox2.DataBindings.Add("Text", BindingSourceOrders, "OrderDate", True)
        TextBox3.DataBindings.Add("Text", BindingSourceOrders, "ShipName", True)
        TextBox4.DataBindings.Add("Text", BindingSourceOrders, "Freight", True, DataSourceUpdateMode.OnValidation, Nothing, "C2")

        Dim employees = From emps In dcNW.Employees _
                        Order By emps.LastName _
                        Select emps

        BindingSourceEmployees.DataSource = employees
        ' BindingSourceEmployees.DataSource = dcNW.Employees

        With ComboBox1
            .DataSource = BindingSourceEmployees
            .DisplayMember = "LastName"
            .ValueMember = "EmployeeID"
            .DataBindings.Add("SelectedValue", BindingSourceOrders, _
                                          "EmployeeID", True, DataSourceUpdateMode.OnPropertyChanged)
        End With

        Label2.DataBindings.Add("Text", BindingSourceEmployees, "FirstName")
        Label3.DataBindings.Add("Text", BindingSourceEmployees, "EmployeeID")
        Label4.DataBindings.Add("Text", BindingSourceEmployees, "Title")
    End Sub

    ' Abbrechen
    Private Sub ToolStripButton10_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton10.Click
        BindingSourceOrders.CancelEdit()
    End Sub

    ' Speichern
    Private Sub ToolStripButton9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton9.Click
        BindingSourceOrders.EndEdit()
        Try
            dcNW.SubmitChanges()      ' !!!
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub


    ' Beenden
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Me.Close()
    End Sub


End Class
