Imports System.Data
Imports System.IO
Imports System.Xml
Imports System.Text

Public Partial Class Beispiel_TreeView
Inherits System.Web.UI.Page

    Private taMitarbeiter As FirmaTableAdapters.MitarbeiterTableAdapter = New FirmaTableAdapters.MitarbeiterTableAdapter()
    Private taTelefone As FirmaTableAdapters.TelefonTableAdapter = New FirmaTableAdapters.TelefonTableAdapter()
    Private myFirma As Firma = New Firma()

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs)
        taMitarbeiter.Fill(myFirma.Mitarbeiter)
        taTelefone.Fill(myFirma.Telefon)
    End Sub

    Protected Sub Button1_Click(ByVal sender As Object, ByVal e As EventArgs)
        TreeView1.Nodes.Clear()
        TreeView1.Nodes.Add(New TreeNode("Mitarbeiter"))
        For Each row As Firma.MitarbeiterRow In myFirma.Mitarbeiter
            Dim tn As TreeNode = New TreeNode()
            tn.Text = row.vorname + " " + row.nachname
            tn.Value = row.id.ToString()
            tn.PopulateOnDemand = True
            TreeView1.Nodes(0).ChildNodes.Add(tn)
        Next
    End Sub

    Protected Sub TreeView1_TreeNodePopulate(ByVal sender As Object, ByVal e As TreeNodeEventArgs)
        Dim rows As Data.DataRow() = myFirma.Telefon.[Select]("MitarbeiterId=" + e.Node.Value)
        For Each row As Firma.TelefonRow In rows
            Dim tn As TreeNode = New TreeNode()
            tn.Text = "Telefon: " + row.Nummer
            e.Node.ChildNodes.Add(tn)
        Next
    End Sub

    Protected Sub TreeView1_SelectedNodeChanged(ByVal sender As Object, ByVal e As EventArgs)
        Label1.Text = TreeView1.SelectedNode.Text
    End Sub

    Public Function ConvertDataSetToXML(ByVal ds As Data.DataSet) As String
        Dim stream As MemoryStream = Nothing
        Dim writer As XmlTextWriter = Nothing
        Try
            stream = New MemoryStream()
            writer = New XmlTextWriter(stream, Encoding.Unicode)
            ds.WriteXml(writer, XmlWriteMode.WriteSchema)
            Dim count As Long = stream.Length
            Dim arr As Byte() = New Byte(count) {}
            stream.Seek(0, SeekOrigin.Begin)
            stream.Read(arr, 0, count)
            Dim utf As UnicodeEncoding = New UnicodeEncoding()
            Return utf.GetString(arr).Trim()
        Catch
            Return [String].Empty
        Finally
            If writer IsNot Nothing Then
                writer.Close()
            End If
        End Try
    End Function

    Protected Sub Button2_Click(ByVal sender As Object, ByVal e As EventArgs)
    End Sub
End Class
