Public Partial Class Firmenverwaltung
Inherits System.Web.UI.Page

    Private taMitarbeiter As FirmaTableAdapters.MitarbeiterTableAdapter = New FirmaTableAdapters.MitarbeiterTableAdapter()
    Private taTelefone As FirmaTableAdapters.TelefonTableAdapter = New FirmaTableAdapters.TelefonTableAdapter()
    Private myFirma As Firma = New Firma()

    Protected Sub Refresh()
        taMitarbeiter.Fill(myFirma.Mitarbeiter)
        If GridView1.SelectedValue Is Nothing Then
            taTelefone.Fill(myFirma.Telefon)
        Else
            taTelefone.FillByMitarbeiter(myFirma.Telefon, DirectCast(GridView1.SelectedValue, Integer))
        End If
        GridView1.DataSource = myFirma.Mitarbeiter
        GridView2.DataSource = myFirma.Telefon
        Me.DataBind()
    End Sub

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        Refresh()
    End Sub

    Protected Sub Button1_Click(ByVal sender As Object, ByVal e As EventArgs) Handles Button1.Click
        myFirma.Mitarbeiter.AddMitarbeiterRow(TextBox1.Text, TextBox2.Text, Convert.ToDecimal(TextBox3.Text))
        taMitarbeiter.Update(myFirma.Mitarbeiter)
        Refresh()
    End Sub

    Protected Sub Button2_Click(ByVal sender As Object, ByVal e As EventArgs) Handles Button2.Click
        If GridView1.SelectedValue Is Nothing Then
            Return
        End If
        Dim tr As Firma.TelefonRow = myFirma.Telefon.NewTelefonRow()
        tr.MitarbeiterId = DirectCast(GridView1.SelectedValue, Integer)
        tr.Nummer = TextBox7.Text
        myFirma.Telefon.AddTelefonRow(tr)
        taTelefone.Update(myFirma.Telefon)
        Refresh()
    End Sub

    Protected Sub GridView1_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)
        Refresh()
    End Sub

    Protected Sub Button3_Click(ByVal sender As Object, ByVal e As EventArgs) Handles Button3.Click
        Dim id As Integer = Convert.ToInt32(taMitarbeiter.NeuerMitarbeiter(TextBox5.Text, TextBox4.Text, 100))
        taTelefone.Insert(TextBox6.Text, id)
        Refresh()
    End Sub

    Protected Sub Button4_Click(ByVal sender As Object, ByVal e As EventArgs) Handles Button4.Click
        If GridView1.SelectedValue Is Nothing Then
            Return
        End If
        taTelefone.Insert(TextBox7.Text, DirectCast(GridView1.SelectedValue, Integer))
        Refresh()
    End Sub

    Protected Sub GridView2_RowDeleting(ByVal sender As Object, ByVal e As GridViewDeleteEventArgs)
        Response.Write(e.Values(0))
    End Sub

    Protected Sub Button5_Click(ByVal sender As Object, ByVal e As EventArgs) Handles Button5.Click
        For Each row As Firma.MitarbeiterRow In myFirma.Mitarbeiter
            Response.Write("Name " + row.vorname + " " + row.nachname + " Gehalt: " + row.gehalt.ToString("c") + "<br>")
        Next
    End Sub
End Class
