Imports System
Imports System.Web
Imports System.Web.Services
Imports System.Web.Services.Protocols
Imports System.Collections.Generic
Imports System.Data
Imports System.Data.SqlClient
Imports System.Configuration
Imports System.ComponentModel

<DataObject(True)> _
Public Class SessionWarenkorb

	Private _ArtikelListe As List(Of Artikel)

	Private Session As System.Web.SessionState.HttpSessionState = HttpContext.Current.Session

	Public Sub New()
		If Session("Warenkorb") IsNot Nothing Then
			_ArtikelListe = DirectCast(Session("Warenkorb"), List(Of Artikel))
		Else
			_ArtikelListe = New List(Of Artikel)()
		End If
	End Sub 

	<DataObjectMethod(DataObjectMethodType.[Select])> _
	Public Function GetArtikelListe() As List(Of Artikel)
		Return _ArtikelListe
	End Function

	<DataObjectMethod(DataObjectMethodType.Update)> _
	Public Sub UpdateArtikel(ByVal updArtikel As Artikel)
		For Each art As Artikel In _ArtikelListe
			If art.Id = updArtikel.Id Then
				art.Bezeichnung = updArtikel.Bezeichnung
				art.Preis = updArtikel.Preis
				art.Anzahl = updArtikel.Anzahl
				Exit For
			End If
		Next
		Session("Warenkorb") = _ArtikelListe
	End Sub

	<DataObjectMethod(DataObjectMethodType.Delete)> _
	Public Sub DeleteArtikel(ByVal delArtikel As Artikel)
		For i As Integer = 0 To _ArtikelListe.Count - 1
			If _ArtikelListe(i).Id = delArtikel.Id Then
				_ArtikelListe.RemoveAt(i)
				Exit For
			End If
		Next
		Session("Warenkorb") = _ArtikelListe
	End Sub

	<DataObjectMethod(DataObjectMethodType.Insert)> _
	Public Sub InsertArtikel(ByVal insArtikel As Artikel)
		Dim Counter As Integer = 0
		For Each art As Artikel In _ArtikelListe
			If art.Id > Counter Then
				Counter = art.Id
			End If
		Next
		Counter += 1
		_ArtikelListe.Add(New Artikel(insArtikel.Bezeichnung, insArtikel.Preis, insArtikel.Anzahl, Counter))
		Session("Warenkorb") = _ArtikelListe
	End Sub
End Class
