Public Class CSpesen

    '  Hilfsprozedur fr Verpflegungspauschale fr An- oder Abreisetag lt. Spesentabelle (dat1 und dat2 sind DatumZeit-Werte vom gleichen Tag):
    Private Shared Function oneDay(ByVal dat1 As DateTime, ByVal dat2 As DateTime) As Double
        Dim betrag As Double = 0
        Dim stunden As Integer = (dat2 - dat1).Hours  ' liefert abgerundete Stunden aus Datumsdifferenz
        If stunden >= 8 Then betrag += 6.0 ' 6 Euro ab  8 Stunden 
        If stunden >= 14 Then betrag += 6.0 ' 12 Euro ab 14 Stunden
        Return betrag
    End Function

    ' Hauptprozedur fr Verpflegungspauschale (bergeben werden Beginn und Ende der Reise):
    Public Shared Function getSpesen(ByVal beginn As DateTime, ByVal ende As DateTime) As Double
        Dim vp As Double = 0           ' V-Pauschale
        ' Hilfsvariablen d1 und d2 sind ohne Zeitanteil:
        Dim sd1 As String = beginn.ToShortDateString()
        Dim d1 As DateTime = Convert.ToDateTime(sd1)  ' 0-Uhr am Anreisetag
        Dim sd2 As String = ende.ToShortDateString()
        Dim d2 As DateTime = Convert.ToDateTime(sd2)   ' ........ Abreisetag

        Dim tage As Integer = (d2 - d1).Days + 1          ' Reisedauer in Tagen
        If tage = 1 Then vp += oneDay(beginn, ende) ' eintgige Reise
        If tage > 1 Then
            Dim d1E As DateTime = d1.AddDays(1)     ' Ende des Anreisetags (0-Uhr am zweiten Tag)
            vp += oneDay(beginn, d1E)          ' Spesen fr Anreisetag
            vp += oneDay(d2, ende)             ' ......     Abreisetag
        End If
        If tage > 2 Then vp += 24.0 * (tage - 2) ' 24 Euro fr vollen Tag
        Return (vp)
    End Function
End Class


