﻿Imports Microsoft.Synchronization
Imports Microsoft.Synchronization.Data
Imports Microsoft.Synchronization.Data.Server

Public Class Form1

    Private Sub ProductsBindingNavigatorSaveItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ProductsBindingNavigatorSaveItem.Click
        Me.Validate()
        Me.ProductsBindingSource.EndEdit()
        Me.TableAdapterManager.UpdateAll(Me.NorthwindDataSet)
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'TODO: Diese Codezeile lädt Daten in die Tabelle "NorthwindDataSet.Products". Sie können sie bei Bedarf verschieben oder entfernen.
        Me.ProductsTableAdapter.Fill(Me.NorthwindDataSet.Products)

    End Sub

    Private Sub button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim syncAgent As New NWCacheSyncAgent()
        Dim syncStats As Microsoft.Synchronization.Data.SyncStatistics = syncAgent.Synchronize()
        ListBox1.Items.Add("TotalChangesDownloaded : " & syncStats.TotalChangesDownloaded.ToString())
        Me.ProductsTableAdapter.Fill(Me.NorthwindDataSet.Products)
    End Sub

    Private Sub SyncProgress(ByVal sender As Object, ByVal e As Microsoft.Synchronization.Data.SyncProgressEventArgs)
        Dim msg As String = ""

        Select Case e.SyncStage
            Case SyncStage.ApplyingInserts
                If e.TableProgress.Inserts > 0 Then
                    msg = "INSERT: Client -> Server " & e.TableMetadata.TableName & "[" & e.TableProgress.Inserts.ToString() & "]"
                End If
            Case SyncStage.ApplyingUpdates
                If e.TableProgress.Updates > 0 Then
                    msg = "UPDATE: Client -> Server " & e.TableMetadata.TableName & "[" & e.TableProgress.Updates.ToString() & "]"
                End If
            Case SyncStage.ApplyingDeletes
                If e.TableProgress.Deletes > 0 Then
                    msg = "DELETE: Client -> Server " & e.TableMetadata.TableName & "[" & e.TableProgress.Deletes.ToString() & "]"
                End If
            Case SyncStage.GettingInserts
                If e.TableProgress.Inserts > 0 Then
                    msg = "INSERT: Client <- Server " & e.TableMetadata.TableName & "[" & e.TableProgress.Inserts.ToString() & "]"
                End If
            Case SyncStage.GettingUpdates
                If e.TableProgress.Updates > 0 Then
                    msg = "UPDATE: Client <- Server " & e.TableMetadata.TableName & "[" & e.TableProgress.Updates.ToString() & "]"
                End If
            Case SyncStage.GettingDeletes
                If e.TableProgress.Deletes > 0 Then
                    msg = "DELETE: Client <- Server " & e.TableMetadata.TableName & "[" & e.TableProgress.Deletes.ToString() & "]"
                End If
        End Select

        If msg <> "" Then
            ListBox1.Items.Add(msg)
        End If
        Application.DoEvents()
    End Sub

    Private Sub syncAgent_StateChanged(ByVal sender As Object, ByVal e As Microsoft.Synchronization.SessionStateChangedEventArgs)
        ListBox1.Items.Add(e.SessionState.ToString())
    End Sub

    Private Sub syncAgent_SessionProgress(ByVal sender As Object, ByVal e As Microsoft.Synchronization.SessionProgressEventArgs)
        progressBar1.Value = e.PercentCompleted
    End Sub



    Private Sub button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        ListBox1.Items.Clear()
        Me.Validate()
        Me.ProductsBindingSource.EndEdit()
        Me.TableAdapterManager.UpdateAll(Me.NorthwindDataSet)
        Dim syncAgent As New NWCacheSyncAgent()
        AddHandler syncAgent.SessionProgress, AddressOf syncAgent_SessionProgress
        AddHandler syncAgent.StateChanged, AddressOf syncAgent_StateChanged
        AddHandler TryCast(syncAgent.RemoteProvider, DbServerSyncProvider).SyncProgress, AddressOf SyncProgress
        syncAgent.Products.SyncDirection = Microsoft.Synchronization.Data.SyncDirection.Bidirectional
        Dim syncStats As Microsoft.Synchronization.Data.SyncStatistics = syncAgent.Synchronize()
        ListBox1.Items.Add("TotalChangesDownloaded : " & syncStats.TotalChangesDownloaded.ToString())
        Me.ProductsTableAdapter.Fill(Me.NorthwindDataSet.Products)
        progressBar1.Value = 0
    End Sub
End Class
