﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms

Imports System.Data.Linq
Imports System.Data.Linq.Mapping
Imports System.Diagnostics

Public Class TestDatenbank

    Private dbTest As TestDataContext

    Private Sub button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button1.Click
        Dim filename As String = "'" & Application.UserAppDataPath & "\School.mdf'"
        dbTest = New TestDataContext("Data Source=.\SQLEXPRESS;AttachDbFilename=" & filename & ";Integrated Security=True")
        If (Not dbTest.DatabaseExists()) Then
            dbTest.CreateDatabase()
        End If
        ' Performance-Verbesserung

            'Dim options As New DataLoadOptions()
            'options.LoadWith(Of Teacher)(Function(Teacher) Teacher.Student)
            'dbTest.LoadOptions = options

            'Dim options As New DataLoadOptions()
            'options.LoadWith(Of Teacher)(Function(Teacher) Teacher.Bemerkungen)
            'dbTest.LoadOptions = options
        dbTest.Log = Console.Out
    End Sub

    Private Sub button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button3.Click
        Dim teachers = From t In dbTest.Teacher _
                       Select t
        teacherBindingSource.DataSource = teachers
    End Sub

    Private Sub button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button4.Click
        Dim i As Integer = dbTest.Teacher.Where(Function(t) t.Geburtstag < Convert.ToDateTime("31.12.1950")).Count()
        MessageBox.Show("Lehrer: " & i.ToString())
    End Sub

    Private Sub button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button5.Click
        Try
            dbTest.SubmitChanges(ConflictMode.ContinueOnConflict)
        Catch
            For Each o In dbTest.ChangeConflicts
                o.Resolve(RefreshMode.KeepChanges)
            Next o
        End Try
        dbTest.SubmitChanges(ConflictMode.FailOnFirstConflict)
    End Sub

    Private Sub button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button6.Click
        Dim Lehrer As New Teacher()
        Lehrer.Nachname = "Müller"
        Lehrer.Vorname = "Heinz"
        Lehrer.Geburtstag = Convert.ToDateTime("1.1.1967")
        dbTest.Teacher.InsertOnSubmit(Lehrer)
    End Sub

    Private Sub button13_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button13.Click
        Dim Lehrer As New Teacher()
        Lehrer.Nachname = "Honigmund"
        Lehrer.Vorname = "Isolde"
        Lehrer.Geburtstag = Convert.ToDateTime("1.1.1987")
        teacherBindingSource.Add(Lehrer)
    End Sub

    Private Sub button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button7.Click
        Dim Lehrer As New Teacher()
        Lehrer.Nachname = "Mayer"
        Lehrer.Vorname = "Franz"
        Lehrer.Geburtstag = Convert.ToDateTime("1.1.1952")
        dbTest.Teacher.InsertOnSubmit(Lehrer)
        dbTest.SubmitChanges()
        MessageBox.Show("Die neue ID:" & Lehrer.Id.ToString())

    End Sub

    Private Sub button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button8.Click
        Dim Lehrer As New Teacher()
        Lehrer.Nachname = "Lehmann"
        Lehrer.Vorname = "Gustav"
        Lehrer.Geburtstag = Convert.ToDateTime("11.11.1950")
        Dim s As New Student()
        s.Vorname = "Hans"
        s.Nachname = "Wurst"
        s.Geburtstag = Convert.ToDateTime("11.11.1981")
        Lehrer.Student.Add(s)
        dbTest.Teacher.InsertOnSubmit(Lehrer)
    End Sub

    Private Sub button9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button9.Click
        Dim Lehrer As New Teacher()
        Lehrer.Nachname = "Müller"
        Lehrer.Vorname = "Norbert"
        Lehrer.Geburtstag = Convert.ToDateTime("22.11.1972")

        Lehrer.Student.Add(New Student("Barth", "Hans", Convert.ToDateTime("4.6.1990")))
        Lehrer.Student.Add(New Student("Barth", "Jan", Convert.ToDateTime("5.6.1990")))
        Lehrer.Student.Add(New Student("Kohl", "Blumen", Convert.ToDateTime("1.4.1982")))
        dbTest.Teacher.InsertOnSubmit(Lehrer)
    End Sub

    Private Sub button10_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button10.Click
        Dim q = _
            From t In dbTest.Teacher _
            Where t.Student.Count > 2 _
            Select t
        teacherBindingSource.DataSource = q
    End Sub

    Private Sub button11_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button11.Click
        MessageBox.Show("Der jüngste Student: " & (TryCast(teacherBindingSource.Current, Teacher)).Student.Max(Function(s) s.Geburtstag).Year.ToString())
    End Sub

    Private Sub button12_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button12.Click
        For Each row As DataGridViewRow In teacherDataGridView.SelectedRows
            MessageBox.Show(row.Cells(0).Value.ToString())
            Dim lehrer = dbTest.Teacher.Where(Function(t) t.Id = CInt(Fix(row.Cells(0).Value))).First()
            ' Und weg damit
            dbTest.Student.DeleteAllOnSubmit(lehrer.Student)
            ' Und jetzt der Lehrer
            dbTest.Teacher.DeleteOnSubmit(lehrer)
            ' Alternativ:  dbTest.KillTeacherById(CType(row.Cells(0).Value, Int16))
        Next row
    End Sub

    Private Sub button14_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button14.Click
        Dim teachers = (From t In dbTest.Teacher _
                        Select t).Skip(2).Take(3)
        teacherBindingSource.DataSource = teachers
    End Sub

    Private Sub button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button2.Click
        dbTest.Refresh(RefreshMode.OverwriteCurrentValues, dbTest.Teacher)
        teacherBindingSource.CurrencyManager.Refresh()
    End Sub

    Private Sub timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles timer1.Tick
        Try
            Dim cs As ChangeSet = dbTest.GetChangeSet()
            listBox1.DataSource = cs.Inserts
            listBox2.DataSource = cs.Updates
            listBox3.DataSource = cs.Deletes
        Catch
        End Try
    End Sub

    Private Sub TeacherDataGridView_DataError(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewDataErrorEventArgs) Handles TeacherDataGridView.DataError

    End Sub
End Class