﻿Imports System.ComponentModel
Imports System.Data
Imports System.Linq
Imports System.Diagnostics
Imports System.Data.Objects
Imports System.Data.Common

Imports System.Data.EntityClient
Imports System.Data.Metadata.Edm


Public Class Form1

    Private ctx As VereinDBEntities

    Private Sub ObjectStateManager_ObjectStateManagerChanged(ByVal sender As Object, ByVal e As CollectionChangeEventArgs)
        listBox1.Items.Insert(0, e.Action.ToString() & ": " & e.Element.ToString())
    End Sub


    Private Sub button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button1.Click
        ctx = New VereinDBEntities()
        AddHandler ctx.ObjectStateManager.ObjectStateManagerChanged, AddressOf ObjectStateManager_ObjectStateManagerChanged
    End Sub

    Private Sub button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button2.Click
        dataGridView1.DataSource = ctx.Mitglieder
        ' lästigerweise werden auch die Navigation-Properties angezeigt, also weg damit
        Try
            dataGridView1.Columns.Remove("Vereinsvorsitze")
            dataGridView1.Columns.Remove("Vereinsmitgliedschaften")
        Catch
        End Try
    End Sub

    Private Sub button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button3.Click
        Try
            ctx.SaveChanges()
        Catch ex As OptimisticConcurrencyException
            ctx.Refresh(System.Data.Objects.RefreshMode.StoreWins, ctx.Mitglieder)
            ctx.SaveChanges()
        End Try
    End Sub

    Private Sub button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button4.Click
        Dim m As Mitglieder = Mitglieder.CreateMitglieder(0, "Hans", "Glück")
        ' ärgerlicher Weise wird auch die ID abgefragt, obwohl diese schreibgeschützt ist 
        ctx.AddToMitglieder(m)
        ' alternative Schreibweise
        ctx.AddToMitglieder(Mitglieder.CreateMitglieder(0, "Paul", "Waldner"))
        ctx.AddToMitglieder(Mitglieder.CreateMitglieder(0, "Werner", "Wiesengrün"))
    End Sub

    Private Sub button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button5.Click
        Dim v As New Vereine()
        v.Name = "Taubenzüchter"
        v.Ort = "Bad Taubhausen"
        v.PLZ = "12345"
        v.Strasse = "Bienengasse 333"
        v.Mitgliedsliste.Add(ctx.Mitglieder.Where(Function(m) m.Nachname = "Glück").First())
        ' hinzufügen des Vorsitzenden bzw. ablegen in der Liste
        ctx.Mitglieder.Where(Function(m) m.Nachname = "Glück").First().VereinsVorsitze.Add(v)
    End Sub

    Private Sub button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button6.Click
        ' Erst der Verein
        Dim v As New Vereine()
        v.Name = "VB-Freunde"
        v.Ort = "Frankfurt"
        v.PLZ = "54321"
        v.Strasse = "Programiererweg 5"
        ' Dann die Mitglieder
        v.Mitgliedsliste.Add(Mitglieder.CreateMitglieder(0, "Thomas", "Gewinnus"))
        v.Mitgliedsliste.Add(Mitglieder.CreateMitglieder(0, "Walter", "Doberenz"))
        ' den Vorsitzenden dürfen wir nicht vergessen zuzuweisen
        v.Vorsitzender = v.Mitgliedsliste.Where(Function(m) m.Nachname = "Gewinnus").First()
        ' und das Ganze noch in die Vereinsliste einfügen
        ctx.AddToVereine(v)
    End Sub

    Private Sub button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button7.Click
        Dim ver As Vereine = ctx.Vereine.First(Function(v) v.Name.Contains("VB"))
        MessageBox.Show(ver.Name + ": " + ver.EntityState.ToString())
        ctx.Dispose()
        ver.Name = "VB-Freunde 2008 e.V."
        MessageBox.Show(ver.Name + ": " + ver.EntityState.ToString())

        ' hier könnte serialisiert etc. werden 
        ' irgendwann später ...

        ctx = New VereinDBEntities()
        ' Originalobjekt in Context laden !!!
        ' Dim old As Vereine = ctx.Vereine.First(Function(v) v.Name.Contains("VB"))
        ' ctx.ApplyPropertyChanges("Vereine",ver)

        ' Alternativ mit
        Dim ek As EntityKey = ctx.CreateEntityKey("Vereine", ver)
        Dim old As Object
        If ctx.TryGetObjectByKey(ek, old) Then
            ctx.ApplyPropertyChanges("Vereine", ver)
        End If

        ctx.SaveChanges()

    End Sub

    Private Sub button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button8.Click
        Dim id As Integer = Int32.Parse(dataGridView1.CurrentRow.Cells(0).Value.ToString())
        ' so eine komplizierter Zugriff !!!
        Dim ver = ctx.Mitglieder.Include("VereinsMitgliedschaften").FirstOrDefault(Function(m) m.Id = id).VereinsMitgliedschaften
        ' alternativ
        'Dim ver = ctx.Mitglieder.FirstOrDefault(Function(m) m.Id = id).VereinsMitgliedschaften
        'ver.Load() // ab hier sind erst relevante Daten enthalten

        dataGridView2.DataSource = ver

    End Sub

    Private Sub button9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button9.Click
        Dim ml = ctx.Vereine.Include("Mitgliedsliste").Where(Function(v) v.Name.Contains("VB")).FirstOrDefault().Mitgliedsliste
        dataGridView2.DataSource = ml
    End Sub

    Private Sub button10_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button10.Click
        Dim verein = ctx.Vereine.Include("Vorsitzender").Where(Function(v) v.Name.Contains("VB")).FirstOrDefault()
        MessageBox.Show(verein.Name)
        ' alternativ zu Include verein.VorsitzenderReference.Load()
        MessageBox.Show(verein.Vorsitzender.Vorname & " " & verein.Vorsitzender.Nachname)
    End Sub

    Private Sub button11_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button11.Click
        listBox1.Items.Clear()
        For Each en In ctx.ObjectStateManager.GetObjectStateEntries(EntityState.Modified)
            listBox1.Items.Add(("Änderung für: " & en.EntityKey.EntityContainerName) & "." & en.EntityKey.EntitySetName.ToString() & "." & en.EntityKey.EntityKeyValues.First().Key & " = " & en.EntityKey.EntityKeyValues.First().Value)
            For i As Integer = 0 To en.CurrentValues.FieldCount - 1
                listBox1.Items.Add(en.CurrentValues.DataRecordInfo.FieldMetadata(i).FieldType.ToString() & ": " & en.OriginalValues(i) & " -> " & en.CurrentValues(i))
            Next
            listBox1.Items.Add("")
        Next
        For Each en In ctx.ObjectStateManager.GetObjectStateEntries(EntityState.Deleted)
            listBox1.Items.Add("Gelöscht: " & en.EntityKey.EntityContainerName & "." & en.EntityKey.EntitySetName & "." & en.EntityKey.EntityKeyValues.First().Key & " = " & en.EntityKey.EntityKeyValues.First().Value)
            listBox1.Items.Add("")
        Next
        For Each en In ctx.ObjectStateManager.GetObjectStateEntries(EntityState.Added)
            listBox1.Items.Add("Hinzugefügt: " & en.EntityKey.EntityContainerName & "." & en.EntityKey.EntitySetName)
            For i As Integer = 0 To en.CurrentValues.FieldCount - 1
                listBox1.Items.Add(en.CurrentValues.DataRecordInfo.FieldMetadata(i).FieldType.ToString() & ": " & en.CurrentValues(i))
            Next
            listBox1.Items.Add("")
        Next

    End Sub

    Private Sub Button12_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button12.Click
        Using conn As New EntityConnection("Name=VereinDBEntities")
            conn.Open()
            Dim cmd As EntityCommand = conn.CreateCommand()
            cmd.CommandText = "SELECT VALUE m FROM VereinDBEntities.Mitglieder AS m ORDER BY m.Nachname"
            Dim dr As DbDataReader = cmd.ExecuteReader(CommandBehavior.SequentialAccess)
            While dr.Read()
                listBox1.Items.Add(dr("Nachname").ToString())
            End While
            dr.Close()
        End Using
    End Sub

    Private Sub Button13_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button13.Click
        Dim ctx As New VereinDBEntities()
        '        Dim query = ctx.CreateQuery(Of Mitglieder)("SELECT VALUE m FROM VereinDBEntities.Mitglieder AS m ORDER BY m.Nachname")
        Dim query = ctx.CreateQuery(Of Vereine)("SELECT VALUE v FROM VereinDBEntities.Vereine AS v WHERE v.Vorsitzender.Nachname == 'Gewinnus'")
        '.Include("Vereinsmitgliedschaften")
        dataGridView1.DataSource = query
    End Sub

    Private Sub Button14_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button14.Click
        Dim ctx As New VereinDBEntities()
        dataGridView1.DataSource = ctx.Kleinwagen ' => FEHLER
    End Sub
End Class
