Imports System.Data
Imports System.Data.SqlClient
Imports System.Web.Configuration   ' Zugriff auf Web.Config
Imports System.Web.Services

' [System.Web.Script.Services.ScriptService]
<WebService([Namespace]:="http://tempuri.org/")> _
<WebServiceBinding(ConformsTo:=WsiProfiles.BasicProfile1_1)> _
Public Class DOKOWebShop
    Inherits System.Web.Services.WebService

    Private Connstr As String = WebConfigurationManager.ConnectionStrings("DatabaseConnectionString").ToString()

    Private Function AdminCheck(ByVal email As String, ByVal passwort As String) As Boolean
        Dim Admin As Boolean = False
        Dim conn As New SqlConnection(Connstr)
        Dim cmd As New SqlCommand("CurrentUser", conn)
        cmd.CommandType = CommandType.StoredProcedure
        cmd.Parameters.AddWithValue("@EMail", email)
        cmd.Parameters.AddWithValue("@Passwort", passwort)
        conn.Open()
        Dim dr As SqlDataReader = cmd.ExecuteReader()
        If dr.Read() Then
            Admin = CBool(dr("IsAdmin"))
        End If
        conn.Close()
        Return Admin
    End Function


    'Auskommentierung der folgenden Zeile bei Verwendung von Designkomponenten aufheben 
    'InitializeComponent(); 
    Public Sub New()
    End Sub

    <WebMethod()> _
    Public Function Get_Stammdaten() As DataSet
        Dim conn As New SqlConnection(Connstr)
        Dim da1 As New SqlDataAdapter("SELECT * FROM Artikel", conn)
        Dim da2 As New SqlDataAdapter("SELECT * FROM ArtikelGruppen", conn)
        Dim da3 As New SqlDataAdapter("SELECT * FROM Steuersaetze", conn)
        da1.MissingSchemaAction = MissingSchemaAction.AddWithKey
        da2.MissingSchemaAction = MissingSchemaAction.AddWithKey
        da3.MissingSchemaAction = MissingSchemaAction.AddWithKey
        Dim ds As New DataSet("Stammdaten")
        conn.Open()
        da1.Fill(ds, "Artikel")
        da2.Fill(ds, "ArtikelGruppen")
        da3.Fill(ds, "Steuersaetze")
        ds.Relations.Add("R1", ds.Tables("Artikelgruppen").Columns("Id"), ds.Tables("Artikel").Columns("ArtikelGruppenID"))
        ds.Relations.Add("R2", ds.Tables("Steuersaetze").Columns("Id"), ds.Tables("Artikel").Columns("MwStSatz"))
        conn.Close()
        Return ds
    End Function

    <WebMethod()> _
    Public Function Set_Stammdaten(ByRef dsStammdaten As DataSet, ByVal email As String, ByVal passwort As String) As Boolean
        If AdminCheck(email, passwort) Then
            Dim conn As New SqlConnection(Connstr)
            Dim da1 As New SqlDataAdapter("SELECT * FROM Artikel", conn)
            Dim da2 As New SqlDataAdapter("SELECT * FROM ArtikelGruppen", conn)
            da1.ContinueUpdateOnError = True
            da2.ContinueUpdateOnError = True
            Dim cb1 As New SqlCommandBuilder(da1)
            Dim cb2 As New SqlCommandBuilder(da2)
            conn.Open()
            da1.Update(dsStammdaten.Tables("Artikel"))
            da2.Update(dsStammdaten.Tables("ArtikelGruppen"))
            conn.Close()
            Return True
        Else
            Return False
        End If
    End Function

    <WebMethod()> _
    Public Function Get_Kunden() As DataSet
        Dim conn As New SqlConnection(Connstr)
        Dim da As New SqlDataAdapter("SELECT * FROM Nutzer", conn)
        da.MissingSchemaAction = MissingSchemaAction.AddWithKey
        Dim ds As New DataSet("Nutzer")
        conn.Open()
        da.Fill(ds, "Nutzer")
        conn.Close()
        Return ds
    End Function

    <WebMethod()> _
    Public Function Set_Kunden(ByRef dsStammdaten As DataSet, ByVal email As String, ByVal passwort As String) As Boolean
        If AdminCheck(email, passwort) Then
            Dim conn As New SqlConnection(Connstr)
            Dim da As New SqlDataAdapter("SELECT * FROM Nutzer", conn)
            da.ContinueUpdateOnError = True
            Dim cb As New SqlCommandBuilder(da)
            conn.Open()
            da.Update(dsStammdaten.Tables("Nutzer"))
            conn.Close()
            Return True
        Else
            Return False
        End If
    End Function

    <WebMethod()> _
    Public Function Get_Bestellungen() As DataSet
        Dim conn As New SqlConnection(Connstr)
        Dim cmd As New SqlCommand("Bestellliste", conn)
        cmd.CommandType = CommandType.StoredProcedure
        Dim da As New SqlDataAdapter(cmd)
        Dim ds As New DataSet("Bestellungen")
        conn.Open()
        da.Fill(ds, "Bestellungen")
        conn.Close()
        Return ds
    End Function

    <WebMethod()> _
    Public Function Get_BestellDetails(ByVal BestellId As Int32) As DataSet
        Dim conn As New SqlConnection(Connstr)
        Dim da1 As New SqlDataAdapter("SELECT * FROM Bestellungen WHERE ID=@ID", conn)
        da1.SelectCommand.Parameters.AddWithValue("@ID", BestellId)

        Dim da2 As New SqlDataAdapter("SELECT * FROM BestellungsDetails WHERE BestellungenID=@ID", conn)
        da2.SelectCommand.Parameters.AddWithValue("@ID", BestellId)

        Dim ds As New DataSet("Rechnungsdaten")
        conn.Open()
        da1.Fill(ds, "Bestellungen")
        da2.Fill(ds, "BestellungsDetails")

        conn.Close()
        Return ds
    End Function


End Class
