﻿Imports System.Data
Imports System.Linq

Partial Public Class _Default
    Inherits System.Web.UI.Page

    Private db As New DBShopDataContext()
    Private dtWarenkorb As New DataTable()

    Public Sub GotoPage(ByVal frm As String)
        Dim uc As MyUserControl = DirectCast(Page.LoadControl(frm & ".ascx"), MyUserControl)
        uc.ID = "MyUserControl1"        ' Wichtig: Zuweisen einer ID !!!
        uc.FormTree = Me.TreeView1      ' Zuweisen des Navigationsbaums
        uc.Warenkorb = dtWarenkorb
        PlaceHolder1.Controls.Clear()
        PlaceHolder1.Controls.Add(uc)
        ViewState("frm") = frm
    End Sub

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs)
        If Not IsPostBack Then
            ' Treeview füllen
            For Each ag As ArtikelGruppen In db.ArtikelGruppen
                Dim tn As New TreeNode()
                tn.Text = ag.Titel
                tn.Value = ag.Id.ToString()
                TreeView1.Nodes(0).ChildNodes.Add(tn)
            Next

            ' Warenkorb temporär erzeugen
            dtWarenkorb.Columns.Add("Id", Type.GetType("System.Int16"))
            dtWarenkorb.Columns.Add("Name", Type.GetType("System.String"))
            dtWarenkorb.Columns.Add("Anzahl", Type.GetType("System.Int16"))
            dtWarenkorb.Columns.Add("EPreis", Type.GetType("System.Decimal"))
            dtWarenkorb.Columns.Add("GPreis", Type.GetType("System.Decimal"))
            dtWarenkorb.Columns.Add("MWSt", Type.GetType("System.Int16"))
            Session.Add("Warenkorb", dtWarenkorb)

            ' Nutzerverwaltung
            Session.Add("User", 0)      ' undefinierter User
            Session.Add("Admin", False) ' keine Rechte
            Session.Timeout = 15        ' 15 Minuten
            If Request.Cookies("Username") IsNot Nothing Then
                txtUserName.Text = Request.Cookies("Username").Value
            End If
        Else
            If Session("User") Is Nothing Then ' undefinierter User
                Session.Add("User", 0)
            End If

            If ViewState("frm") IsNot Nothing Then
                ' Dynamisch geladenen Controls wiederherstellen
                GotoPage(ViewState("frm").ToString())
            End If
        End If
        If CInt(Session("User")) <> 0 Then ' Anmeldung bereits erfolgt
            btnLogin.Text = "Logout"
            Panel1.Visible = False
        End If
        If PlaceHolder1.Controls.Count = 0 Then
            GotoPage("Welcome")
        End If
    End Sub

    Protected Sub TreeView1_SelectedNodeChanged1(ByVal sender As Object, ByVal e As EventArgs)
        If TreeView1.SelectedNode.Text.Contains("Warenkorb") Then
            GotoPage("Warenkorb")
        End If
        If TreeView1.SelectedNode.Text.Contains("Ihre Daten") Then
            GotoPage("KundenKonto")
        End If
        If TreeView1.SelectedNode.Parent IsNot Nothing Then       ' Es handelt sich um Untereinträge
            If TreeView1.SelectedNode.Parent.Text = "Shop" Then   ' Eine Artikelrubrik
                Session("Artikelgruppe") = TreeView1.SelectedNode.Value
                Session("ArtikelId") = -1
                GotoPage("Shop")
            End If
        End If
    End Sub

    Protected Sub Button1_Click(ByVal sender As Object, ByVal e As EventArgs)
        If btnLogin.Text = "Logout" Then
            btnLogin.Text = "Login"
            Session("User") = 0           ' undefinierter User
            Session("Admin") = False      ' keine Rechte
            Panel1.Visible = True
        Else
            Dim user = db.CurrentUser(txtUserName.Text, txtPasswort.Text).FirstOrDefault()
            ' email und passwort
            If user IsNot Nothing Then
                Session("User") = user.Id
                Session("Admin") = user.IsAdmin
                btnLogin.Text = "Logout"
                lblMeldung.Visible = False
                Dim cookie As New HttpCookie("UserName", txtUserName.Text)
                cookie.Expires = DateTime.Now.AddDays(30)  ' 30 Tage gültig
                Response.Cookies.Add(cookie)
                Panel1.Visible = False
            Else
                btnLogin.Text = "Login"
                lblMeldung.Visible = True
            End If
        End If
    End Sub
End Class
