﻿Imports Microsoft.Reporting.WinForms   ' !


Public Class Form1

    Private ws As New localhost.DOKOWebShop()
    Private dsStammdaten As New DataSet()
    Private dsBestellungen As New DataSet()
    Private dsRechnung As New DataSet()
    Private dsKunden As New DataSet()

    Private Sub MyDataChange(ByVal sender As Object, ByVal e As DataRowChangeEventArgs)
        Button1.Enabled = dsStammdaten.HasChanges()
    End Sub


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        dsStammdaten = ws.Get_Stammdaten()
        dataGridView1.DataSource = dsStammdaten.Tables("Artikelgruppen")
        dataGridView1.Columns(0).Width = 20
        dataGridView1.Columns(1).HeaderText = "Artikelgruppe"
        dataGridView1.Columns(1).Width = 150

        dataGridView2.DataSource = dsStammdaten.Tables("Artikel")
        dataGridView2.Columns.Remove("Id")
        dataGridView2.Columns.Remove("ArtikelgruppenID")
        dataGridView2.Columns.Remove("Beschreibung")
        dataGridView2.Columns.Remove("MWStSatz")

        dataGridView2.Columns("Titel").Width = 190
        dataGridView2.Columns("NettoPreis").Width = 80
        dataGridView2.Columns("NettoPreis").DefaultCellStyle.Format = "c"
        dataGridView2.Columns("NettoPreis").DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight

        '          Mehrwertsteuersätze auswählen
        Dim cbc1 As New DataGridViewComboBoxColumn()
        cbc1.DataSource = dsStammdaten.Tables("Steuersaetze")
        cbc1.DataPropertyName = "MwStSatz"
        cbc1.ValueMember = "Id"
        cbc1.DisplayMember = "Titel"
        ' Detailanzeige 
        cbc1.HeaderText = "Steuersatz"
        cbc1.Width = 130
        cbc1.DisplayStyle = DataGridViewComboBoxDisplayStyle.[Nothing]
        dataGridView2.Columns.Add(cbc1)


        ' Artikelgruppe auswählen
        Dim cbc2 As New DataGridViewComboBoxColumn()
        cbc2.DataSource = dsStammdaten.Tables("Artikelgruppen")
        cbc2.DataPropertyName = "ArtikelgruppenID"
        cbc2.ValueMember = "Id"
        cbc2.DisplayMember = "Titel"
        ' Detailanzeige 
        cbc2.HeaderText = "Artikelgruppe"
        cbc2.Width = 150
        cbc2.DisplayStyle = DataGridViewComboBoxDisplayStyle.[Nothing]
        cbc2.SortMode = DataGridViewColumnSortMode.Automatic
        dataGridView2.Columns.Add(cbc2)

        textBox1.DataBindings.Add("Text", dsStammdaten.Tables("Artikel"), "Beschreibung")

        ' Veränderungen in den Tabellen berücksichtigen
        AddHandler dsStammdaten.Tables("Artikel").RowChanged, New DataRowChangeEventHandler(AddressOf MyDataChange)
        AddHandler dsStammdaten.Tables("Artikelgruppen").RowChanged, New DataRowChangeEventHandler(AddressOf MyDataChange)

        ' Bestellnummern abrufen
        dsBestellungen = ws.Get_Bestellungen()
        ComboBox1.DataSource = dsBestellungen.Tables("Bestellungen")
        ComboBox1.DisplayMember = "Rechnung"
        ComboBox1.ValueMember = "Id"
        Me.ReportViewer1.RefreshReport()
    End Sub

    Private Sub button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        If (dsStammdaten IsNot Nothing) AndAlso (dsStammdaten.HasChanges()) Then
            Dim dsHelp As DataSet = dsStammdaten.GetChanges()
            If ws.Set_Stammdaten(dsHelp, "tg@tg.de", "geheim") Then
                dsStammdaten.Merge(dsHelp)
                dsStammdaten.AcceptChanges()
                Button1.Enabled = False
                MessageBox.Show("Daten erfolgreich aktualisiert!")
            Else
                dsStammdaten.RejectChanges()
                MessageBox.Show("Schreibzugriff nicht möglich! Wahrscheinlich haben Sie nicht die dazu erforderlichen Rechte.")
            End If
        End If
    End Sub

    Private Sub ComboBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged
        Try
            dsRechnung = ws.Get_BestellDetails(CType(ComboBox1.SelectedValue, Int32))
            ReportViewer1.LocalReport.DataSources.Clear()
            ReportViewer1.LocalReport.DataSources.Add(New ReportDataSource("dsRechnungsdaten_Bestellungen", New BindingSource(dsRechnung, "Bestellungen")))
            ReportViewer1.LocalReport.DataSources.Add(New ReportDataSource("dsRechnungsdaten_BestellungsDetails", New BindingSource(dsRechnung, "BestellungsDetails")))
            ReportViewer1.RefreshReport()
        Catch
        End Try
    End Sub

    Private Sub tabControl1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tabControl1.SelectedIndexChanged
        If tabControl1.SelectedIndex = 2 Then
            dsKunden = ws.Get_Kunden()
            dataGridView3.DataSource = dsKunden.Tables("Nutzer")
            dataGridView3.Columns.Remove("Id")
            dataGridView3.Columns("IsAdmin").Width = 50
        End If
    End Sub

    Private Sub dataGridView1_SelectionChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles dataGridView1.SelectionChanged
        If checkBox1.Checked Then
            Dim gridTable As DataTable = DirectCast(dataGridView2.DataSource, DataTable)
            gridTable.DefaultView.RowFilter = "ArtikelgruppenID = " & DirectCast(dataGridView1.CurrentRow.DataBoundItem, DataRowView).Row(0).ToString()
        End If
    End Sub

    Private Sub checkBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles checkBox1.CheckedChanged
        If checkBox1.Checked Then
            Dim gridTable As DataTable = DirectCast(dataGridView2.DataSource, DataTable)
            gridTable.DefaultView.RowFilter = "ArtikelgruppenID = " & DirectCast(dataGridView1.CurrentRow.DataBoundItem, DataRowView).Row(0).ToString()
        Else
            Dim gridTable As DataTable = DirectCast(dataGridView2.DataSource, DataTable)
            gridTable.DefaultView.RowFilter = ""
        End If
    End Sub

    Private Sub dataGridView2_DefaultValuesNeeded(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewRowEventArgs) Handles dataGridView2.DefaultValuesNeeded
        e.Row.Cells(0).Value = "?"
        e.Row.Cells(1).Value = "0"
        e.Row.Cells(2).Value = dsStammdaten.Tables("Steuersaetze").Rows(0).Field(Of Integer)("ID").ToString()
        e.Row.Cells(3).Value = DirectCast(dataGridView1.CurrentRow.DataBoundItem, DataRowView).Row(0).ToString()
    End Sub

    Private Sub button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button2.Click
        If (dsKunden IsNot Nothing) AndAlso (dsKunden.HasChanges()) Then
            Dim dsHelp As DataSet = dsKunden.GetChanges()
            If ws.Set_Kunden(dsHelp, "tg@tg.de", "geheim") Then
                dsKunden.Merge(dsHelp)
                dsKunden.AcceptChanges()
                MessageBox.Show("Daten erfolgreich aktualisiert!")
            Else
                dsKunden.RejectChanges()
                MessageBox.Show("Schreibzugriff nicht möglich! Wahrscheinlich haben Sie nicht die dazu erforderlichen Rechte.")
            End If
        End If
    End Sub
End Class
